using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Web;
using System.Web.SessionState;
using System.Web.UI;
using System.Web.UI.WebControls;
using System.Web.UI.HtmlControls;

namespace MaxicodeStreamCS
{
	/// <summary>
	/// Summary description for IDAutomationMaxicodeImage.
	/// </summary>
	public class IDAutomationMaxicodeImage : System.Web.UI.Page
	{
		protected IDAutomation.MaxicodeServerControl.Maxicode Maxicode1;
	
		private void Page_Load(object sender, System.EventArgs e)
		{
			//Put user code to initialize the page here
			//During the page load event we will set all parameters for the control			
			//Checking the Parameters using Params.Get is NOT case sensitive.  
			//However, when we use the Equals method of the string data type it IS case sensitive

			//Set the Data to Encode
			if(Request.Params.Get("Barcode") != "" && Request.Params.Get("Barcode") != null)
				Maxicode1.DataToEncode = Request.Params.Get("Barcode");        

			//Set the Postal code (zip code)
			if(Request.Params.Get("PC") != "" && Request.Params.Get("PC") != null)
				Maxicode1.ZipCode = Request.Params.Get("PC");        

			//set the country code
			if(Request.Params.Get("CO") != "" && Request.Params.Get("CO") != null)
				Maxicode1.CountryCode = Request.Params.Get("CO");        

			//set the service class code
			if(Request.Params.Get("SC") != "" && Request.Params.Get("SC") != null)
				Maxicode1.ServiceClass = Request.Params.Get("SC");        

			//Determine if ApplyTilde is turned on
			if(Request.Params.Get("PT") != "" && Request.Params.Get("PT") != null)
			{
				string trunValue = Request.Params.Get("PT");
				if(trunValue.Equals("Y") == true || trunValue.Equals("Yes") == true ||
					trunValue.Equals("True") == true || trunValue.Equals("TRUE") == true ||
					trunValue.Equals("true") == true || trunValue.Equals("yes") == true ||
					trunValue.Equals("y") == true)
					Maxicode1.ApplyTilde = true;
				else
					Maxicode1.ApplyTilde = false;
			}
        
			//Set the resolution of the returned image
			if(Request.Params.Get("IR") != "" && Request.Params.Get("IR") != null)
			{
				try
				{
					Maxicode1.ImageResolution = Convert.ToInt32(Request.Params.Get("IR"));
				}
				catch
				{
					System.Diagnostics.Debug.Write("Invalid entry for Image Resolution parameter");
				}
			}        

			//set the rotation
			if(Request.Params.Get("Rotate") != "" && Request.Params.Get("Rotate") != null)
			{
				if(Request.Params.Get("Rotate").Equals("90"))
					Maxicode1.RotationAngle = IDAutomation.MaxicodeServerControl.RotationAngles.Ninety_Degrees;
				else if(Request.Params.Get("Rotate").Equals("180"))
					Maxicode1.RotationAngle = IDAutomation.MaxicodeServerControl.RotationAngles.One_Hundred_Eighty_Degrees;
				else if(Request.Params.Get("Rotate").Equals("270"))
					Maxicode1.RotationAngle = IDAutomation.MaxicodeServerControl.RotationAngles.Two_Hundred_Seventy_Degrees;
				else
					Maxicode1.RotationAngle = IDAutomation.MaxicodeServerControl.RotationAngles.Zero_Degrees;
			}        

			//Set the encoding mode
			if(Request.Params.Get("MODE") != "" && Request.Params.Get("MODE") != null)
			{
				try
				{
					int modeValue = Convert.ToInt32(Request.Params.Get("MODE"));
					switch(modeValue)
					{
						case 2:
							Maxicode1.EncodingMode = IDAutomation.MaxicodeServerControl.EncodingModes.Mode2;
							break;
						case 3:
							Maxicode1.EncodingMode = IDAutomation.MaxicodeServerControl.EncodingModes.Mode3;
							break;
						case 4:
							Maxicode1.EncodingMode = IDAutomation.MaxicodeServerControl.EncodingModes.Mode4;
							break;
						case 5:
							Maxicode1.EncodingMode = IDAutomation.MaxicodeServerControl.EncodingModes.Mode5;
							break;
						case 6:
							Maxicode1.EncodingMode = IDAutomation.MaxicodeServerControl.EncodingModes.Mode6;
							break;
						default:
							Maxicode1.EncodingMode = IDAutomation.MaxicodeServerControl.EncodingModes.Mode2;
							break;
					}
				}
				catch
				{
					System.Diagnostics.Debug.Write("Invalid entry for Maxicode Encoding Mode value");
					Maxicode1.EncodingMode = IDAutomation.MaxicodeServerControl.EncodingModes.Mode2;
				}
			}

			if (Request.Params.Get("RESOLUTION") != "" && Request.Params.Get("RESOLUTION") != null)
				Maxicode1.ImageResolution = Convert.ToInt32(Request.Params.Get("RESOLUTION"));
			
			if(Request.Params.Get("FORMAT") != "" && Request.Params.Get("FORMAT") != null)
			{
				if(Request.Params.Get("FORMAT").Equals("GIF"))
				{
					Response.ContentType="image/gif";
					Maxicode1.GetBitmapImageForBinaryStream().Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Gif);
				}
				else
				{
					Response.ContentType="image/jpeg";
					Maxicode1.GetBitmapImageForBinaryStream().Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg);
				}
			}
			else 
			{
				Response.ContentType="image/gif";
				Maxicode1.GetBitmapImageForBinaryStream().Save(Response.OutputStream, System.Drawing.Imaging.ImageFormat.Jpeg);
			}

		}

		#region Web Form Designer generated code
		override protected void OnInit(EventArgs e)
		{
			//
			// CODEGEN: This call is required by the ASP.NET Web Form Designer.
			//
			InitializeComponent();
			base.OnInit(e);
		}
		
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{    
			this.Load += new System.EventHandler(this.Page_Load);

		}
		#endregion

	}
}
